/********************************************************************-*-c-*-*\
*               *  Class examples for Advanced Porgramming                   *
*    #####      *  (!) Giovanni Squillero <giovanni.squillero@polito.it>     *
*   ######      *                                                            *
*   ###   \     *  Copying and distribution of this file, with or without    *
*    ##G  c\    *  modification, are permitted in any medium without royalty *
*    #     _\   *  provided this notice is preserved.                        *
*    |   _/     *  This file is offered as-is, without any warranty.         *
*    |  _/      *                                                            *
*               *  See: http://staff.polito.it/giovanni.squillero/dida.php   *
\****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "liste.h"
#include "utils.h"

LIST *ListNew(void)
{
	LIST *L;

	L = Malloc(sizeof (LIST));
	L->head = NULL;
	return L;
}

DATA *ListSearch(LIST *L, char *key)
{
	ELEM *E;

	E=L->head;
	while(E && strcmp(key, E->data.word))
		E=E->next;
	return E ? &E->data : NULL;
}

void ListAdd(LIST *L, DATA *D)
{
	ELEM *N;
	N = Malloc(sizeof (ELEM));
	memcpy(&N->data, D, sizeof (DATA));
	N->next = L->head;	
	L->head = N;
}

void ListPrint(LIST *L)
{
	ELEM *E;

	for(E=L->head; E; E=E->next) 
		printf("0x%x: \"%s\" %d\n", E, E->data.word, E->data.num);
}

void ListDelete(LIST *L, char *key)
{
	ELEM *E, *PE;
	
	PE=NULL;
	E=L->head;
	while(strcmp(E->data.word, key)) {
		PE=E;
		E=E->next;
	}
	if(PE)
		PE->next = E->next;
	else
		L->head = E->next;
	free(E);
}











