/********************************************************************-*-c-*-*\
*               *  Class examples for Advanced Porgramming                   *
*    #####      *  (!) Giovanni Squillero <giovanni.squillero@polito.it>     *
*   ######      *                                                            *
*   ###   \     *  Copying and distribution of this file, with or without    *
*    ##G  c\    *  modification, are permitted in any medium without royalty *
*    #     _\   *  provided this notice is preserved.                        *
*    |   _/     *  This file is offered as-is, without any warranty.         *
*    |  _/      *                                                            *
*               *  See: http://staff.polito.it/giovanni.squillero/dida.php   *
\****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "liste.h"
#include "utils.h"

LIST *ListNew(void)
{
	LIST *L;
	ELEM *S1, *S2;
	
	S1 = Malloc(sizeof (ELEM));
	strcpy(S1->data.word, "");
	S1->data.num = -1;

	S2 = Malloc(sizeof (ELEM));
	S2->data.word[0] = 127;
	S2->data.word[1] = '\0';
	S2->data.num = -1;

	L = Malloc(sizeof (LIST));
	S1->next = S2;
	S2->prec = S1;
	S2->next = NULL;
	S1->prec = NULL;
	L->head = S1;
	L->nElem = 0;

	return L;
}

DATA *ListSearch(LIST *L, char *key)
{
	ELEM *E;

	E=L->head;
	while(strcmp(key, E->data.word)>0)
		E=E->next;
	if(!strcmp(key, E->data.word)) 
		return &E->data;
	else
		return NULL;
}

void ListAdd(LIST *L, DATA *D)
{
	ELEM *N;
	ELEM *T;
	N = Malloc(sizeof (ELEM));
	memcpy(&N->data, D, sizeof (DATA));

	T=L->head;
	while(strcmp(T->next->data.word, D->word)<0) 
		T=T->next;
		
	N->next = T->next;
	N->next->prec = N;
	T->next = N;	
	N->prec = T;
	++L->nElem;
}

void ListDelete(LIST *L, char *key)
{
	ELEM *E, *PE;
	
	PE=NULL;
	E=L->head;
	while(strcmp(E->data.word, key)) {
		PE=E;
		E=E->next;
	}
	PE->next = E->next;
	E->next->prec = PE;
	free(E);
	--L->nElem;
}

void ListPrint(LIST *L)
{
	ELEM *E;

	for(E=L->head->next; E->next; E=E->next) 
		printf("0x%x: \"%s\" %d\n", E, E->data.word, E->data.num);
	printf("La lista contiene %d elementi (+2 sentinelle)\n", L->nElem);
}

